#if !defined(AFX_PARSER_H__7830FD60_54C6_11D2_8864_9D0DD3024277__INCLUDED_)
#define AFX_PARSER_H__7830FD60_54C6_11D2_8864_9D0DD3024277__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afx.h>
#include <afxtempl.h>


enum {
		//oddelovace a operatory		
		nilT, idT, intT, realT, stringT, errorT, endlineT, endfileT,
		commaT,leftpT,rightpT,ekvT,dotT,asterixT,
		//datove typy
		binaryT,bitT,byteT,counterT,currencyT,datetimeT,doubleT,guidT,
		longT,longbinaryT,longtextT,shortT,singleT,textT,valueT,
		//rezervovana slova
		addT,allT,alterT,andT,anyT,asT,ascT,avgT,
		betweenT,byT,
		columnT,constraintT,countT,createT,
		databaseT,deleteT,descT,disallowT,distinctT,distinctrowT,dropT,
		eqvT,existT,
		foreignT,fromT,
		groupT,
		havingT,
		ignoreT,impT,inT,indexT,innerT,insertT,intoT,isT,
		joinT,
		keyT,
		leftT,likeT,
		maxT,minT,modT,
		notT,nullT,
		onT,optionT,orT,orderT,owneraccessT,
		parametersT,percentT,pivotT,primaryT,procedureT,
		referencesT,rightT,
		selectT,setT,someT,stdevT,stdevpT,sumT,
		tableT,topT,transformT,
		unionT,uniqueT,updateT,
		valuesT,varT,varpT,viewT,
		whereT,withT,
		xorT
	};

class CLexicalAnalyser;

class CToken  
{
public:
	CToken();
	virtual ~CToken();
	int getTokenType() { return TokenType;}
	CString getTokenName() { return TokenName;}
	int getTokenInt(){ return TokenInt;}
	double getTokenReal(){ return TokenReal;}

	int TokenType;

	CString TokenName;
	union
	{
			int TokenInt;
			double TokenReal;
	};


};

class CSymbol  
{
public:
	CSymbol();
	CSymbol( CString string, int type);
	virtual ~CSymbol();

	CString SymbolString;
	int TokenType;

	bool operator < (CSymbol &Symbol);
	bool operator <= (CSymbol &Symbol);

	bool operator > (CSymbol &Symbol);
	bool operator >= (CSymbol &Symbol);

};

class CLexicalAnalyser  
{
public:
	void print();
	void SetCurrentPosition(POSITION pos);
	POSITION GetCurrentPosition();
	void ClearAllTokens();
	void ResetPosition();
	bool IsAllAplhaOrDigit(CString s,int begin, int length);
	BOOL IsSequenceEmpty();
	void AddToken(CToken token);
	CToken NextToken();
	CToken GetCurrentToken();
	void Text2TokenSequence(char* sequence);
	void setSymbol(CSymbol Symbol);
	CLexicalAnalyser();
	virtual ~CLexicalAnalyser();

protected:
	POSITION CurrentPosition;
	CArray<CSymbol,CSymbol &> SymbolTable;
	CList<CToken, CToken &> TokenSequence;

};

#endif // !defined(AFX_PARSER_H__7830FD60_54C6_11D2_8864_9D0DD3024277__INCLUDED_)
